﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Map;
using Infragistics.Silverlight.Controls;
using System.Windows.Media.Imaging;
using System.Collections.ObjectModel;
namespace GVFFEI_NEW
{
    public partial class MainPage : UserControl
    {
        string connString;
        SqlDbServiceReference.SqlDbServiceClient client;
        MapGridData mgd;
        public MainPage()
        {
            InitializeComponent();           
            connString = "Integrated Security=True;Initial Catalog=sampledata;Data Source=IE11DT485ZL1S";
            client=new GVFFEI_NEW.SqlDbServiceReference.SqlDbServiceClient();            
        }

        public void client_GetDataCompleted(object sender, SqlDbServiceReference.GetDataCompletedEventArgs e)
        {
            SqlShapeReader sqlReader = myMap.Layers["Layer1"].Reader as SqlShapeReader;
            if (sqlReader != null)
            {
                sqlReader.DataSource = e.Result;
                myMap.Layers["Layer1"].ImportAsync();
            }
            SqlDbServiceReference.SqlDbServiceClient client1 = new GVFFEI_NEW.SqlDbServiceReference.SqlDbServiceClient();
            client1.GetDataCompleted +=new EventHandler<GVFFEI_NEW.SqlDbServiceReference.GetDataCompletedEventArgs>(client1_GetDataCompleted);
            client1.GetDataAsync(connString, "select * from plantlevel2");
        }

        public void client1_GetDataCompleted(object sender, SqlDbServiceReference.GetDataCompletedEventArgs e)
        {
            SqlShapeReader sqlReader = myMap.Layers["Layer2"].Reader as SqlShapeReader;
            if (sqlReader != null)
            {
                sqlReader.DataSource = e.Result;
                myMap.Layers["Layer2"].ImportAsync();
            }
            SqlDbServiceReference.SqlDbServiceClient client2 = new GVFFEI_NEW.SqlDbServiceReference.SqlDbServiceClient();
            client2.GetDataCompleted += new EventHandler<GVFFEI_NEW.SqlDbServiceReference.GetDataCompletedEventArgs>(client2_GetDataCompleted);
            client2.GetDataAsync(connString, "select * from plantlevel3");
        }

        public void client2_GetDataCompleted(object sender, SqlDbServiceReference.GetDataCompletedEventArgs e)
        {
            SqlShapeReader sqlReader = myMap.Layers["Layer3"].Reader as SqlShapeReader;
            if (sqlReader != null)
            {
                sqlReader.DataSource = e.Result;
                myMap.Layers["Layer3"].ImportAsync();
            }
            //SqlDbServiceReference.SqlDbServiceClient client1 = new GVFFEI_NEW.SqlDbServiceReference.SqlDbServiceClient();
            //client1.GetDataCompleted += new EventHandler<GVFFEI_NEW.SqlDbServiceReference.GetDataCompletedEventArgs>(client1_GetDataCompleted);
            //client1.GetDataAsync(connString, "select * from plantlevel2");
        }

        private MapGridData GetSampleData()
        {
            MapGridData data = new MapGridData()
            {
                new MapGridDataItem() { Name = "Air Temp Sensor", Id=1002 , Temp=35.5, LastChecked="23/10/2009"},
                /*new MapGridDataItem() { Name = "ram", Age=28 },
                new MapGridDataItem() { Name = "raja", Age=42 },
                new MapGridDataItem() { Name = "babu", Age=56 },
                new MapGridDataItem() { Name = "depak", Age=19 },
                new MapGridDataItem() { Name = "John", Age=64 }*/
                
            };
            return data;
        }
        /**********************************************************
         *              Map Element Click Event Handler
         **********************************************************/ 
        private void myMap_ElementClick(object sender, MapElementClickEventArgs e)
        {
            for (int i = 0; i < myMap.Layers.Count; i++)
                foreach (MapElement ele in (sender as XamWebMap).Layers[i].Elements)
                {
                    //  MessageBox.Show(map1.Layers[i].LayerName);
                    if (MapData.GetValueData(ele) != null &&
                        MapData.GetValueData(ele).GetType() == typeof(MapGridData))
                    {
                        MapData.SetValueData(ele, null);
                    }
                }
            mgd = GetSampleData();
            mgd.Title = e.Element.Name;
            mgd.visi = Visibility.Visible;
            MapData.SetValueData(e.Element, mgd);
        }

        /**********************************************************
         *              Map Loaded Event Handler
         **********************************************************/
        private void myMap_Loaded(object sender, RoutedEventArgs e)
        {
            client.GetDataCompleted += new EventHandler<GVFFEI_NEW.SqlDbServiceReference.GetDataCompletedEventArgs>(client_GetDataCompleted);
            client.GetDataAsync(connString, "select * from plantlevel1");
        }
    }
    

    /*****************************************************************
     *             Code for seleccting Appropriate Template      
     * ***************************************************************/


    public class MapGridDataItem
    {
        public string Name { get; set; }
        public int Id { get; set; }
        public double Temp { get; set; }
        public string LastChecked { get; set; }
    }

    public class MapGridData : ObservableCollection<MapGridDataItem>
    {
        public string Title { get; set; }
        public Visibility visi { get; set; }
    }

    public class MapData
        : DependencyObject
    {
        public static readonly DependencyProperty ValueDataProperty = DependencyProperty.RegisterAttached("ValueData",
            typeof(object), typeof(MapData), new PropertyMetadata(null));

        public static object GetValueData(DependencyObject target)
        {
            return target.GetValue(MapData.ValueDataProperty);
        }

        public static void SetValueData(DependencyObject target, object value)
        {
            target.SetValue(MapData.ValueDataProperty, value);
        }
    }

    public class SelectableTemplate
    {
        public string MatchType { get; set; }
        public DataTemplate Template { get; set; }
    }

    public class MapTemplateSelector
        : ContentControl
    {

        public MapTemplateSelector()
        {
            SelectableTemplates = new ObservableCollection<SelectableTemplate>();
        }

        public readonly DependencyProperty ValueProperty = DependencyProperty.Register("Value", typeof(object),
            typeof(MapTemplateSelector), new PropertyMetadata(null, OnValuePropertyChanged));

        public object Value
        {
            get
            {
                return GetValue(ValueProperty);
            }
            set
            {
                SetValue(ValueProperty, value);
            }
        }

        public readonly DependencyProperty SelectableTemplatesProperty = DependencyProperty.Register("SelectableTemplates", typeof(ObservableCollection<SelectableTemplate>),
            typeof(MapTemplateSelector), new PropertyMetadata(null, OnSelectableTemplatesPropertyChanged));

        public ObservableCollection<SelectableTemplate> SelectableTemplates
        {
            get
            {
                return (ObservableCollection<SelectableTemplate>)GetValue(SelectableTemplatesProperty);
            }
            set
            {
                SetValue(SelectableTemplatesProperty, value);
            }
        }

        protected static void OnSelectableTemplatesPropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            (sender as MapTemplateSelector).OnSelectableTemplatesChanged(e);
        }

        protected void UpdateTemplate(Type valueType)
        {
            DataTemplate template = null;
            if (valueType != null)
            {
                MessageBox.Show("1");
                template = GetDataTemplate(valueType);
            }
            if (template != null)
            {
                MessageBox.Show("2");
                Content = template.LoadContent();
            }
            else
            {
                Content = null;
            }
        }

        protected void OnSelectableTemplatesChanged(DependencyPropertyChangedEventArgs e)
        {
            Type valueType = null;
            if (Value != null)
            {
                valueType = Value.GetType();
            }
            UpdateTemplate(valueType);
        }

        protected static void OnValuePropertyChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            (sender as MapTemplateSelector).OnValueChanged(e);
        }

        protected void OnValueChanged(DependencyPropertyChangedEventArgs e)
        {
            Type valueType = null;
            if (e.NewValue != null)
            {
                valueType = e.NewValue.GetType();
            }
            UpdateTemplate(valueType);
            if (Content is FrameworkElement)
            {
                (Content as FrameworkElement).DataContext = e.NewValue;
            }
        }

        protected DataTemplate GetDataTemplate(Type valueType)
        {
            foreach (SelectableTemplate selectable in SelectableTemplates)
            {
                if (selectable.MatchType == valueType.Name)
                {
                    return selectable.Template;
                }
            }

            return null;
        }
    }    
}
